Description

It would be nice to have an official portable Linux distribution, so that one can use Doomsday even if it's not in their distribution
repositories. The goal is to be able to run Doomsday on any Linux distribution that's not very old (like, released after 2014 or so),
without having to install any libraries or compile anything.

Applmage (http://appimage.org/) or Flatpak (http:/flatpak.org/) are two potential solutions that can be used for this. | tend to have a
preference for Applmage, mostly because it can be made to work on old distributions easier (from what I've heard; | don't have actual
experience with Flatpak, but Flatpak seems to require a runtime, unlike Applmage which just needs FUSE support enabled). Other
benefits of Applmage include:

e optional desktop integration (desktop menu entries),

optional signing using GPG 2,

optional delta updates,

compression support,

an application is a single file (like macOS's .app files), so it's easy to copy/move around,

| can assist in doing this, I've already created Applmages for Godot Engine (https:/godotengine.org/) and Minetest (
http://www.minetest.net/). Many projects also officially use and support Applmages for their Linux distributions, such as Krita (

https:/krita.org/).

Associated revisions

Revision b4705500 - 2017-04-12 07:55 - skyjake
Unix|libcore: DENG_BASE_DIR and DENG_LIBRARY_DIR may be relative paths

This allows compiling the application for relocatable use, since
built-in directories are looked up relative to the application binary.

IssuelD #2244

Revision bbfa693e - 2017-04-15 09:33 - skyjake
Unix|CMake: Added CMake variables for base and plugin directories

IssuelD #2244

History

#1 - 2017-04-09 20:27 - skyjake

- Target version set to Build system and tools

Applmage sounds good to me. Doomsday is packaged using CMake + CPack. Do you have any insights into how an Applmage would be created out
of that?

#2 - 2017-04-09 20:27 - skyjake

- Tags changed from linux to linux, Installer

#3 - 2017-04-10 15:13 - Calinou

| don't know the details (I've never used CPack), however, do note that for Applmages to be truly portable, they need to be built on an old distribution
(because packages built on recent distributions won't work on older ones).

But Doomsday requires CMake 3.1, which is not available in Debian 8 (https://packages.debian.org/search?keywords=cmake) nor Ubuntu 14.04 (
http://packages.ubuntu.com/search?keywords=cmake). Either we have to perform some trickery to get CMake 3.1 (or later) to work on such old
distributions, or we have to move our minimum version requirement to Ubuntu 16.04 (likely making it impossible for Ubuntu 14.04 and Debian 8 users
to run the Applmages).

It's also possible to build Applmages from existing binaries as well. Lots of examples are available here: https:/github.com/probonopd/Applmages

#4 - 2017-04-11 10:18 - skyjake

- Subject changed from Create an official portable Linux distribution to Create an official portable Linux distribution (Applmage)

Thanks for the links, they were informative. It looks like it should be pretty easy to make a YAML recipe that builds Doomsday from source and
includes the appropriate dependencies.

I'll make a note to set up a Debian 8 VM and see how that would work. | can always compile the required version of CMake from source.
Is Debian 8 the Linux distribution you would recommend for the widest compatibility?
#5 - 2017-04-12 19:11 - skyjake

- Status changed from New to In Progress

- % Done changed from 0 to 30

I've made some progress. | managed to create a functioning Applmage using the following steps:

e Do a normal build with CMake and install it somewhere (using relative base/library dirs; b4705500).
¢ Fix the .desktop file and icon file manually.
¢ Run linuxdeployat on it.

#6 - 2019-11-27 22:07 - skyjake

- Subject changed from Create an official portable Linux distribution (Applmage) to Create an official portable Linux distribution
- Assignee set to skyjake

- Target version changed from Build system and tools to 2.2 (2019)

- % Done changed from 30 to 70

I've decided to go with Flatpak for now.

Flatpak manifest: https:/qit.skyjake.fi/doomsday/distrib/src/branch/master/flatpak/net.dengine.Doomsday.json

Some tweaks are still needed, though:

o [l Enable FluidSynth plugin (build from source)
o Buildwith FMOE

#7 - 2019-11-28 08:18 - skyjake
- Status changed from In Progress to Resolved

- % Done changed from 70 to 100

Added fluidsynth (2.0.9 built from source). Will leave out FMOD from this since it's closed source.

#8 - 2019-11-28 10:27 - skyjake
- Status changed from Resolved to In Progress

- % Done changed from 100 to 90

There are actually a couple of further things:

o [0l Prepare appdata XML for Flathub submission
¢ Possible Autobuilder integration: make an unstable Flatpak module in addition to (or replacing) the other builds?

#9 - 2019-12-03 17:56 - skyjake
- Status changed from In Progress to Resolved

- % Done changed from 90 to 100

#10 - 2019-12-23 19:13 - skyjake
- Status changed from Resolved to Closed
